/*
 * Created on 25.03.2004
 */
package de.korelstar.tetris;

import java.awt.*;
import java.awt.event.*;

/** Hauptklasse: Startet Tetris-Fenster mit main-Mathode
 * @author Kristof Hamann
 */
public class Tetris extends Frame implements WindowListener, ActionListener {
	/** Version des Programmes */
	public static final float VERSION = 1.0f;

	/** Menue-Leiste vom Fenster */
	Menu menuFile = new Menu("Spiel");
	MenuItem menuItemNew = new MenuItem("Neues Spiel", new MenuShortcut(KeyEvent.VK_F2));
	MenuItem menuItemExit = new MenuItem("Beenden");
	CheckboxMenuItem[] menuItemSpeed = {
		new CheckboxMenuItem("Leicht"),
		new CheckboxMenuItem("Mittel"),
		new CheckboxMenuItem("Schwer"),
		new CheckboxMenuItem("Fr Freaks")};
	int[] speed = {500, 200, 100, 50};
	
	Spielfeld feld;
	
	/** Konstruktor von Tetris -- erffnet ein Fenster */
	public Tetris()
	{
		super("Tetris by KorelStar");
		addWindowListener(this);
		setResizable(false);
		
		Menu menuSpeed = new Menu("Geschwindigkeit");
		menuItemSpeed[0].setState(true);
		for(int i=0; i<menuItemSpeed.length; i++) {
			menuItemSpeed[i].addActionListener(this);
			menuSpeed.add(menuItemSpeed[i]);
		}
		menuItemNew.addActionListener(this);
		menuItemExit.addActionListener(this);

		menuFile.add(menuItemNew);
		menuFile.add(menuSpeed);
		menuFile.add(new MenuItem("-"));
		menuFile.add(menuItemExit);

		MenuBar menuBar = new MenuBar();
		menuBar.add(menuFile);
		setMenuBar(menuBar);
		
		feld = new Spielfeld();
		addKeyListener(feld);
		add(feld);
		pack();
		show();
		feld.startGame();
	}

	public void update(java.awt.Graphics g) {
		paint(g);
	}

	/** Start-Funktion -- instanziiert Tetris */
	public static void main(String[] args) {
		System.out.println("Tetris v"+VERSION+", Autor: Kristof Hamann <www.korelstar.de>");
		new Tetris();
	}

	// WindowListener
	public void windowActivated (WindowEvent e) {}
	public void windowClosed (WindowEvent e) { System.exit(0); }
	public void windowClosing (WindowEvent e) { dispose(); }
	public void windowDeactivated (WindowEvent e) {}
	public void windowDeiconified (WindowEvent e) {}
	public void windowIconified (WindowEvent e) {}
	public void windowOpened (WindowEvent e) {}

	private void parseCheckboxes(int chosen) {
		for(int i=0; i<menuItemSpeed.length; i++) {
			menuItemSpeed[i].setState(false);						
		}
		menuItemSpeed[chosen].setState(true);						
		feld.setSpeed(speed[chosen]);
	}

	// ActionListener
	public void actionPerformed(ActionEvent action) {
		if(action.getSource().equals(menuItemNew)) { feld.startGame(); }
		else if(action.getSource().equals(menuItemExit)) { dispose(); }
		else {
			for(int i=0; i<menuItemSpeed.length; i++) {
				if(action.getSource().equals(menuItemSpeed[i])) {
					parseCheckboxes(i);
				}
			}
		}
	}
}